diff --git a/sys/conf/files b/sys/conf/files
index 5498b794f5..c60537886d 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -66,16 +66,7 @@ dev/disk/iscsi/initiator/isc_subr.c	optional iscsi_initiator scbus
 dev/disk/iscsi/initiator/iscsi.c	optional iscsi_initiator scbus
 dev/disk/iscsi/initiator/iscsi_subr.c	optional iscsi_initiator scbus
 
-crypto/blowfish/bf_skey.c		optional ipsec ipsec_esp
-crypto/des/des_ecb.c			optional ipsec ipsec_esp
-crypto/des/des_setkey.c			optional ipsec ipsec_esp
-crypto/rijndael/rijndael-alg-fst.c	optional ipsec ipsec_esp
-crypto/rijndael/rijndael-api-fst.c	optional ipsec ipsec_esp
-crypto/camellia/camellia.c		optional ipsec ipsec_esp
-crypto/camellia/camellia-api.c		optional ipsec ipsec_esp
-crypto/sha1.c				optional ipsec
 crypto/sha1.c				optional carp
-opencrypto/cast.c			optional ipsec ipsec_esp
 ddb/db_access.c				optional ddb
 ddb/db_kld.c				optional ddb
 ddb/db_break.c				optional ddb
@@ -1562,7 +1553,6 @@ net/raw_cb.c		standard
 net/raw_usrreq.c	standard
 net/route.c		standard
 net/rtsock.c		standard
-net/zlib.c		optional ipsec
 netbt/bt_input.c	optional bluetooth
 netbt/bt_proto.c	optional bluetooth
 netbt/hci_event.c	optional bluetooth
@@ -1797,16 +1787,6 @@ netinet/tcp_syncache.c		optional inet
 netinet/tcp_timer.c		optional inet
 netinet/tcp_usrreq.c		optional inet
 netinet/udp_usrreq.c		optional inet
-netinet6/ah_core.c		optional ipsec
-netinet6/ah_input.c		optional ipsec
-netinet6/ah_output.c		optional ipsec
-netinet6/esp_core.c		optional ipsec ipsec_esp
-netinet6/esp_input.c		optional ipsec ipsec_esp
-netinet6/esp_output.c		optional ipsec ipsec_esp
-netinet6/esp_rijndael.c		optional ipsec ipsec_esp
-netinet6/esp_camellia.c		optional ipsec ipsec_esp
-netinet6/esp_aesctr.c		optional ipsec ipsec_esp
-netinet6/ipsec.c		optional ipsec
 netinet6/dest6.c		optional inet6
 netinet6/frag6.c		optional inet6
 netinet6/icmp6.c		optional inet6
@@ -1821,9 +1801,6 @@ netinet6/ip6_input.c		optional inet6
 netinet6/ip6_mroute.c		optional inet6
 netinet6/ip6_output.c		optional inet6
 netinet6/in6_src.c		optional inet6
-netinet6/ipcomp_core.c		optional ipsec
-netinet6/ipcomp_input.c		optional ipsec
-netinet6/ipcomp_output.c	optional ipsec
 netinet6/in6_pcb.c		optional inet6
 netinet6/in6_proto.c		optional inet6
 netinet6/in6_rmx.c		optional inet6
@@ -1836,21 +1813,6 @@ netinet6/route6.c		optional inet6
 netinet6/scope6.c		optional inet6
 netinet6/udp6_output.c		optional inet6
 netinet6/udp6_usrreq.c		optional inet6
-netproto/ipsec/ipsec.c		optional fast_ipsec
-netproto/ipsec/ipsec_input.c	optional fast_ipsec
-netproto/ipsec/ipsec_mbuf.c	optional fast_ipsec
-netproto/ipsec/ipsec_output.c	optional fast_ipsec
-netproto/ipsec/key.c		optional fast_ipsec
-netproto/ipsec/key_debug.c	optional fast_ipsec
-netproto/ipsec/keysock.c	optional fast_ipsec
-netproto/ipsec/xform_ah.c	optional fast_ipsec
-netproto/ipsec/xform_esp.c	optional fast_ipsec
-netproto/ipsec/xform_ipcomp.c	optional fast_ipsec
-netproto/ipsec/xform_ipip.c	optional fast_ipsec
-netproto/key/key.c		optional ipsec
-netproto/key/key_debug.c	optional ipsec
-netproto/key/keydb.c		optional ipsec
-netproto/key/keysock.c		optional ipsec
 netproto/mpls/mpls_demux.c	optional mpls
 netproto/mpls/mpls_input.c	optional mpls
 netproto/mpls/mpls_output.c	optional mpls
@@ -2239,7 +2201,6 @@ libprop/prop_object.c			standard
 libprop/prop_stack.c			standard
 libprop/prop_string.c			standard
 libprop/prop_rb.c			standard
-crypto/blowfish/bf_ecb.c		optional ipsec ipsec_esp
 crypto/blowfish/bf_skey.c		optional crypto
 crypto/camellia/camellia.c		optional crypto
 crypto/camellia/camellia-api.c		optional crypto
diff --git a/sys/conf/options b/sys/conf/options
index 4ce9c5c86c..792a241802 100644
--- a/sys/conf/options
+++ b/sys/conf/options
@@ -249,11 +249,6 @@ MROUTING		opt_mrouting.h
 PIM			opt_mrouting.h
 INET			opt_inet.h
 INET6			opt_inet6.h
-IPSEC			opt_ipsec.h
-IPSEC_ESP		opt_ipsec.h
-IPSEC_DEBUG		opt_ipsec.h
-IPSEC_FILTERGIF		opt_ipsec.h
-FAST_IPSEC		opt_ipsec.h
 IPDIVERT
 DUMMYNET		opt_ipdn.h
 DUMMYNET_DEBUG		opt_ipdn.h
@@ -271,7 +266,7 @@ IPSTEALTH
 LIBMCHAIN
 MPLS			opt_mpls.h
 TCPDEBUG
-TCP_SIGNATURE		opt_inet.h
+#TCP_SIGNATURE		opt_inet.h
 TCP_DROP_SYNFIN		opt_tcp_input.h
 ICMPPRINTFS
 
diff --git a/sys/config/LINT64 b/sys/config/LINT64
index 975e1db8d8..019cf80bf1 100644
--- a/sys/config/LINT64
+++ b/sys/config/LINT64
@@ -218,36 +218,9 @@ options 	UCONSOLE
 #
 # Protocol families:
 #  Only the INET (Internet) family is officially supported in DragonFly.
-#  Source code for the NS (Xerox Network Service) is provided for amusement
-#  value.
 #
 options 	INET			#Internet communications protocols
 options 	INET6			#IPv6 communications protocols
-options 	IPSEC			#IP security
-options 	IPSEC_ESP		#IP security (crypto; define w/ IPSEC)
-options 	IPSEC_DEBUG		#debug for IP security
-#
-# Set IPSEC_FILTERGIF to force packets coming through a gif tunnel
-# to be processed by any configured packet filtering (ipfw).
-# The default is that packets coming from a tunnel are _not_ processed;
-# they are assumed trusted.
-#
-# Note that enabling this can be problematic as there are no mechanisms
-# in place for distinguishing packets coming out of a tunnel (e.g. no
-# encX devices as found on openbsd).
-#
-#options 	IPSEC_FILTERGIF		#filter ipsec packets from a tunnel
-
-#
-# Experimental IPsec implementation that uses the kernel crypto
-# framework.  This cannot be configured together with IPSEC and
-# (currently) supports only IPv4.  To use this you must also
-# configure the crypto device (see below).  Note that with this
-# you get all the IPsec protocols (e.g. there is no FAST_IPSEC_ESP).
-# IPSEC_DEBUG is used, as above, to configure debugging support
-# within the IPsec protocols.
-#
-#options 	FAST_IPSEC		#new IPsec
 
 options 	MPLS			#Multi-Protocol Label Switching
 
@@ -417,13 +390,15 @@ options                ACCEPT_FILTER_DATA
 options                ACCEPT_FILTER_HTTP
 
 # TCP_SIGNATURE adds support for RFC 2385 (TCP-MD5) digests. These are
-# carried in TCP option 19. This option is commonly used to protect
-# TCP sessions (e.g. BGP) where IPSEC is not available nor desirable.
+# carried in TCP option 19.
 # This is enabled on a per-socket basis using the TCP_SIGNATURE_ENABLE
 # socket option.
-# This requires the use of 'device crypto', 'options IPSEC'
-# or 'device cryptodev'.
-options   TCP_SIGNATURE   #include support for RFC 2385
+# This requires the use of 'device crypto' or 'device cryptodev'.
+#
+# XXX disabled for now until building with it (which broke after removing
+#     IPSEC) is fixed
+#
+#options   TCP_SIGNATURE   #include support for RFC 2385
 
 #
 # TCP_DROP_SYNFIN adds support for ignoring TCP packets with SYN+FIN. This
diff --git a/sys/config/VKERNEL64 b/sys/config/VKERNEL64
index 9d73176ad4..feac3e9901 100644
--- a/sys/config/VKERNEL64
+++ b/sys/config/VKERNEL64
@@ -32,10 +32,6 @@ options		ALTQ_FAIRQ	#fair queue
 #options        ALTQ_NOPCC      #don't use processor cycle counter
 options         ALTQ_DEBUG      #for debugging
 
-options		IPSEC			#IP security
-options		IPSEC_ESP		#IP security (crypto; define w/ IPSEC)
-options		IPSEC_DEBUG		#debug for IP security
-
 options		HAMMER
 options		HAMMER2			#HAMMER2 filesystem
 options		NULLFS			#NULL filesystem
diff --git a/sys/net/pf/if_pfsync.c b/sys/net/pf/if_pfsync.c
index d927af2876..a0d2579bfe 100644
--- a/sys/net/pf/if_pfsync.c
+++ b/sys/net/pf/if_pfsync.c
@@ -470,9 +470,6 @@ pfsync_input(struct mbuf *m, ...)
 	struct pfsync_state_clr *cp;
 	struct pfsync_state_upd_req *rup;
 	struct pfsync_state_bus *bus;
-#ifdef IPSEC
-	struct pfsync_tdb *pt;
-#endif
 	struct in_addr src;
 	struct mbuf *mp;
 	int iplen, action, error, i, count, offp, sfail, stale = 0;
@@ -997,20 +994,6 @@ pfsync_input(struct mbuf *m, ...)
 			break;
 		}
 		break;
-#ifdef IPSEC
-	case PFSYNC_ACT_TDB_UPD:
-		if ((mp = m_pulldown(m, iplen + sizeof(*ph),
-		    count * sizeof(*pt), &offp)) == NULL) {
-			pfsyncstats.pfsyncs_badlen++;
-			return;
-		}
-		crit_enter();
-		for (i = 0, pt = (struct pfsync_tdb *)(mp->m_data + offp);
-		    i < count; i++, pt++)
-			pfsync_update_net_tdb(pt);
-		crit_exit();
-		break;
-#endif
 	}
 
 done:
diff --git a/sys/netinet/in.h b/sys/netinet/in.h
index dc5479c190..f8c1abe095 100644
--- a/sys/netinet/in.h
+++ b/sys/netinet/in.h
@@ -346,8 +346,6 @@ struct sockaddr_in {
 #define	IP_RSVP_VIF_OFF		18   /* unset RSVP per-vif socket */
 #define	IP_PORTRANGE		19   /* int; range to choose for unspec port */
 #define	IP_RECVIF		20   /* bool; receive reception if w/dgram */
-/* for IPSEC */
-#define	IP_IPSEC_POLICY		21   /* int; set/get security policy */
 
 #define	IP_FW_TBL_CREATE	40   /* create ipfw table */
 #define	IP_FW_TBL_DESTROY	41   /* destroy ipfw table */
@@ -457,7 +455,7 @@ struct ip_mreq {
 	{ 0, 0 }, \
 	{ 0, 0 }, \
 	{ 0, 0 }, \
-	{ "ipsec", CTLTYPE_NODE }, \
+	{ 0, 0 }, \
 	{ 0, 0 }, \
 	{ 0, 0 }, \
 	{ 0, 0 }, \
diff --git a/sys/netinet/in_pcb.c b/sys/netinet/in_pcb.c
index 50c42560dd..a6aa6d47fe 100644
--- a/sys/netinet/in_pcb.c
+++ b/sys/netinet/in_pcb.c
@@ -63,7 +63,6 @@
  * $FreeBSD: src/sys/netinet/in_pcb.c,v 1.59.2.27 2004/01/02 04:06:42 ambrisko Exp $
  */
 
-#include "opt_ipsec.h"
 #include "opt_inet6.h"
 
 #include <sys/param.h>
@@ -101,22 +100,6 @@
 #include <netinet6/ip6_var.h>
 #endif /* INET6 */
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#include <netproto/key/key.h>
-#include <netproto/ipsec/esp_var.h>
-#endif
-
-#ifdef FAST_IPSEC
-#if defined(IPSEC) || defined(IPSEC_ESP)
-#error "Bad idea: don't compile with both IPSEC and FAST_IPSEC!"
-#endif
-
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/key.h>
-#define	IPSEC
-#endif /* FAST_IPSEC */
-
 #define INP_LOCALGROUP_SIZMIN	8
 #define INP_LOCALGROUP_SIZMAX	256
 
@@ -247,11 +230,6 @@ in_baddynamic(u_int16_t port, u_int16_t proto)
 	case IPPROTO_TCP:
 		return (DP_ISSET(baddynamicports.tcp, port));
 	case IPPROTO_UDP:
-#ifdef IPSEC
-		/* Cannot preset this as it is a sysctl */
-		if (port == udpencap_port)
-			return (1);
-#endif
 		return (DP_ISSET(baddynamicports.udp, port));
 	default:
 		return (0);
@@ -299,9 +277,6 @@ int
 in_pcballoc(struct socket *so, struct inpcbinfo *pcbinfo)
 {
 	struct inpcb *inp;
-#ifdef IPSEC
-	int error;
-#endif
 
 	inp = kmalloc(pcbinfo->ipi_size, M_PCB, M_WAITOK|M_ZERO|M_NULLOK);
 	if (inp == NULL)
@@ -310,13 +285,6 @@ in_pcballoc(struct socket *so, struct inpcbinfo *pcbinfo)
 	inp->inp_gencnt = ++pcbinfo->ipi_gencnt;
 	inp->inp_pcbinfo = pcbinfo;
 	inp->inp_socket = so;
-#ifdef IPSEC
-	error = ipsec_init_policy(so, &inp->inp_sp);
-	if (error != 0) {
-		kfree(inp, M_PCB);
-		return (error);
-	}
-#endif
 #ifdef INET6
 	if (INP_CHECK_SOCKAF(so, AF_INET6)) {
 		if (ip6_auto_flowlabel)
@@ -1063,9 +1031,6 @@ in_pcbdetach(struct inpcb *inp)
 	struct socket *so = inp->inp_socket;
 	struct inpcbinfo *ipi = inp->inp_pcbinfo;
 
-#ifdef IPSEC
-	ipsec4_delete_pcbpolicy(inp);
-#endif /*IPSEC*/
 	inp->inp_gencnt = ++ipi->ipi_gencnt;
 	KKASSERT((so->so_state & SS_ASSERTINPROG) == 0);
 	in_pcbremlists(inp);
diff --git a/sys/netinet/in_proto.c b/sys/netinet/in_proto.c
index 54e8815059..8f2372ed18 100644
--- a/sys/netinet/in_proto.c
+++ b/sys/netinet/in_proto.c
@@ -32,7 +32,6 @@
 
 #include "opt_ipdivert.h"
 #include "opt_mrouting.h"
-#include "opt_ipsec.h"
 #include "opt_inet6.h"
 #include "opt_carp.h"
 
@@ -71,19 +70,6 @@
  * TCP/IP protocol family: IP, ICMP, UDP, TCP.
  */
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#include <netinet6/ah.h>
-#ifdef IPSEC_ESP
-#include <netinet6/esp.h>
-#endif
-#include <netinet6/ipcomp.h>
-#endif /* IPSEC */
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#endif /* FAST_IPSEC */
-
 #include <net/netisr.h>		/* for cpu0_soport */
 
 #ifdef CARP
@@ -197,96 +183,6 @@ struct protosw inetsw[] = {
 
 	.pr_usrreqs = &rip_usrreqs
     },
-#ifdef IPSEC
-    {
-	.pr_type = SOCK_RAW,
-	.pr_domain = &inetdomain,
-	.pr_protocol = IPPROTO_AH,
-	.pr_flags = PR_ATOMIC|PR_ADDR,
-
-	.pr_input = ah4_input,
-	.pr_output = NULL,
-	.pr_ctlinput = NULL,
-	.pr_ctloutput = NULL,
-
-	.pr_ctlport = NULL,
-	.pr_usrreqs = &nousrreqs
-    },
-#ifdef IPSEC_ESP
-    {
-	.pr_type = SOCK_RAW,
-	.pr_domain = &inetdomain,
-	.pr_protocol = IPPROTO_ESP,
-	.pr_flags = PR_ATOMIC|PR_ADDR,
-
-	.pr_input = esp4_input,
-	.pr_output = NULL,
-	.pr_ctlinput = NULL,
-	.pr_ctloutput = NULL,
-
-	.pr_ctlport = NULL,
-	.pr_usrreqs = &nousrreqs
-    },
-#endif
-    {
-	.pr_type = SOCK_RAW,
-	.pr_domain = &inetdomain,
-	.pr_protocol = IPPROTO_IPCOMP,
-	.pr_flags = PR_ATOMIC|PR_ADDR,
-
-	.pr_input = ipcomp4_input,
-	.pr_output = 0,
-	.pr_ctlinput = NULL,
-	.pr_ctloutput = NULL,
-
-	.pr_ctlport = NULL,
-	.pr_usrreqs = &nousrreqs
-    },
-#endif /* IPSEC */
-#ifdef FAST_IPSEC
-    {
-	.pr_type = SOCK_RAW,
-	.pr_domain = &inetdomain,
-	.pr_protocol = IPPROTO_AH,
-	.pr_flags = PR_ATOMIC|PR_ADDR,
-
-	.pr_input = ipsec4_common_input,
-	.pr_output = NULL,
-	.pr_ctlinput = NULL,
-	.pr_ctloutput = NULL,
-
-	.pr_ctlport = NULL,
-	.pr_usrreqs = &nousrreqs
-    },
-    {
-	.pr_type = SOCK_RAW,
-	.pr_domain = &inetdomain,
-	.pr_protocol = IPPROTO_ESP,
-	.pr_flags = PR_ATOMIC|PR_ADDR,
-
-	.pr_input = ipsec4_common_input,
-	.pr_output = NULL,
-	.pr_ctlinput = NULL,
-	.pr_ctloutput = NULL,
-
-	.pr_ctlport = NULL,
-	.pr_usrreqs = &nousrreqs
-    },
-    {
-	.pr_type = SOCK_RAW,
-	.pr_domain = &inetdomain,
-	.pr_protocol = IPPROTO_IPCOMP,
-	.pr_flags = PR_ATOMIC|PR_ADDR,
-
-	.pr_input = ipsec4_common_input,
-	.pr_output = NULL,
-	.pr_ctlinput = NULL,
-	.pr_ctloutput = NULL,
-
-	.pr_ctlport = NULL,
-	.pr_usrreqs = &nousrreqs
-    },
-#endif /* FAST_IPSEC */
     {
 	.pr_type = SOCK_RAW,
 	.pr_domain = &inetdomain,
@@ -463,18 +359,6 @@ SYSCTL_NODE(_net_inet, IPPROTO_ICMP,	icmp,	CTLFLAG_RW, 0,	"ICMP");
 SYSCTL_NODE(_net_inet, IPPROTO_UDP,	udp,	CTLFLAG_RW, 0,	"UDP");
 SYSCTL_NODE(_net_inet, IPPROTO_TCP,	tcp,	CTLFLAG_RW, 0,	"TCP");
 SYSCTL_NODE(_net_inet, IPPROTO_IGMP,	igmp,	CTLFLAG_RW, 0,	"IGMP");
-#ifdef FAST_IPSEC
-/* XXX no protocol # to use, pick something "reserved" */
-SYSCTL_NODE(_net_inet, 253,		ipsec,	CTLFLAG_RW, 0,	"IPSEC");
-SYSCTL_NODE(_net_inet, IPPROTO_AH,	ah,	CTLFLAG_RW, 0,	"AH");
-SYSCTL_NODE(_net_inet, IPPROTO_ESP,	esp,	CTLFLAG_RW, 0,	"ESP");
-SYSCTL_NODE(_net_inet, IPPROTO_IPCOMP,	ipcomp,	CTLFLAG_RW, 0,	"IPCOMP");
-SYSCTL_NODE(_net_inet, IPPROTO_IPIP,	ipip,	CTLFLAG_RW, 0,	"IPIP");
-#else
-#ifdef IPSEC
-SYSCTL_NODE(_net_inet, IPPROTO_AH,	ipsec,	CTLFLAG_RW, 0,	"IPSEC");
-#endif /* IPSEC */
-#endif /* !FAST_IPSEC */
 SYSCTL_NODE(_net_inet, IPPROTO_RAW,	raw,	CTLFLAG_RW, 0,	"RAW");
 #ifdef IPDIVERT
 SYSCTL_NODE(_net_inet, IPPROTO_DIVERT,	divert,	CTLFLAG_RW, 0,	"DIVERT");
diff --git a/sys/netinet/ip_divert.c b/sys/netinet/ip_divert.c
index 273f1720fe..9b77b928f2 100644
--- a/sys/netinet/ip_divert.c
+++ b/sys/netinet/ip_divert.c
@@ -33,7 +33,6 @@
 
 #include "opt_inet.h"
 #include "opt_ipdivert.h"
-#include "opt_ipsec.h"
 
 #ifndef INET
 #error "IPDIVERT requires INET."
diff --git a/sys/netinet/ip_icmp.c b/sys/netinet/ip_icmp.c
index 9d7920d5c7..28024feeb6 100644
--- a/sys/netinet/ip_icmp.c
+++ b/sys/netinet/ip_icmp.c
@@ -30,8 +30,6 @@
  * $FreeBSD: src/sys/netinet/ip_icmp.c,v 1.39.2.19 2003/01/24 05:11:34 sam Exp $
  */
 
-#include "opt_ipsec.h"
-
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/mbuf.h>
@@ -60,17 +58,6 @@
 #include <netinet/ip_var.h>
 #include <netinet/icmp_var.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#include <netproto/key/key.h>
-#endif
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/key.h>
-#define	IPSEC
-#endif
-
 /*
  * ICMP routines: error generation, receive packet processing, and
  * routines to turnaround packets back to the originator, and
@@ -508,13 +495,7 @@ icmp_redirect_done_handler(netmsg_t nmsg)
 	struct netmsg_ctlinput *msg = (struct netmsg_ctlinput *)nmsg;
 	struct mbuf *m = msg->m;
 	int hlen = msg->hlen;
-#ifdef IPSEC
-	struct sockaddr_in icmpsrc = { sizeof(struct sockaddr_in), AF_INET };
-	struct icmp *icp = mtodoff(m, struct icmp *, hlen);;
 
-	icmpsrc.sin_addr = icp->icmp_ip.ip_dst;
-	key_sa_routechange((struct sockaddr *)&icmpsrc);
-#endif
 	rip_input(&m, &hlen, msg->proto);
 }
 
@@ -912,9 +893,6 @@ icmp_input(struct mbuf **mp, int *offp, int proto)
 			return IPPROTO_DONE;
 		}
 		/* Move on; run rip_input() directly */
-#ifdef IPSEC
-		key_sa_routechange((struct sockaddr *)&icmpsrc);
-#endif
 		break;
 
 	/*
diff --git a/sys/netinet/ip_input.c b/sys/netinet/ip_input.c
index 62ae5b0b8a..0862ee5c9c 100644
--- a/sys/netinet/ip_input.c
+++ b/sys/netinet/ip_input.c
@@ -69,7 +69,6 @@
 #include "opt_ipdn.h"
 #include "opt_ipdivert.h"
 #include "opt_ipstealth.h"
-#include "opt_ipsec.h"
 #include "opt_rss.h"
 
 #include <sys/param.h>
@@ -120,16 +119,6 @@
 #include <net/ipfw/ip_fw.h>
 #include <net/dummynet/ip_dummynet.h>
 
-#ifdef IPSEC
-#include <netinet6/ipsec.h>
-#include <netproto/key/key.h>
-#endif
-
-#ifdef FAST_IPSEC
-#include <netproto/ipsec/ipsec.h>
-#include <netproto/ipsec/key.h>
-#endif
-
 int rsvp_on = 0;
 static int ip_rsvp_on;
 struct socket *ip_rsvpd;
@@ -468,11 +457,6 @@ ip_input(struct mbuf *m)
 	struct m_tag *mtag;
 	struct sockaddr_in *next_hop = NULL;
 	lwkt_port_t port;
-#ifdef FAST_IPSEC
-	struct tdb_ident *tdbi;
-	struct secpolicy *sp;
-	int error;
-#endif
 
 	ASSERT_NETISR_NCPUS(mycpuid);
 	M_ASSERTPKTHDR(m);
@@ -597,13 +581,6 @@ ip_input(struct mbuf *m)
 			m_adj(m, ip->ip_len - m->m_pkthdr.len);
 		}
 	}
-#if defined(IPSEC) && !defined(IPSEC_FILTERGIF)
-	/*
-	 * Bypass packet filtering for packets from a tunnel (gif).
-	 */
-	if (ipsec_gethist(m, NULL))
-		goto pass;
-#endif
 
 	/*
 	 * IpHack's section.
@@ -831,43 +808,6 @@ ip_input(struct mbuf *m)
 		ipstat.ips_cantforward++;
 		m_freem(m);
 	} else {
-#ifdef IPSEC
-		/*
-		 * Enforce inbound IPsec SPD.
-		 */
-		if (ipsec4_in_reject(m, NULL)) {
-			ipsecstat.in_polvio++;
-			goto bad;
-		}
-#endif
-#ifdef FAST_IPSEC
-		mtag = m_tag_find(m, PACKET_TAG_IPSEC_IN_DONE, NULL);
-		crit_enter();
-		if (mtag != NULL) {
-			tdbi = (struct tdb_ident *)m_tag_data(mtag);
-			sp = ipsec_getpolicy(tdbi, IPSEC_DIR_INBOUND);
-		} else {
-			sp = ipsec_getpolicybyaddr(m, IPSEC_DIR_INBOUND,
-						   IP_FORWARDING, &error);
-		}
-		if (sp == NULL) {	/* NB: can happen if error */
-			crit_exit();
-			/*XXX error stat???*/
-			DPRINTF(("ip_input: no SP for forwarding\n"));	/*XXX*/
-			goto bad;
-		}
-
-		/*
-		 * Check security policy against packet attributes.
-		 */
-		error = ipsec_in_reject(sp, m);
-		KEY_FREESP(&sp);
-		crit_exit();
-		if (error) {
-			ipstat.ips_cantforward++;
-			goto bad;
-		}
-#endif
 		ip_forward(m, using_srcrt, next_hop);
 	}
 	return;
@@ -915,58 +855,6 @@ ip_input(struct mbuf *m)
 		ip->ip_len -= hlen;
 	}
 
-#ifdef IPSEC
-	/*
-	 * enforce IPsec policy checking if we are seeing last header.
-	 * note that we do not visit this with protocols with pcb layer
-	 * code - like udp/tcp/raw ip.
-	 */
-	if ((inetsw[ip_protox[ip->ip_p]].pr_flags & PR_LASTHDR) &&
-	    ipsec4_in_reject(m, NULL)) {
-		ipsecstat.in_polvio++;
-		goto bad;
-	}
-#endif
-#ifdef FAST_IPSEC
-	/*
-	 * enforce IPsec policy checking if we are seeing last header.
-	 * note that we do not visit this with protocols with pcb layer
-	 * code - like udp/tcp/raw ip.
-	 */
-	if (inetsw[ip_protox[ip->ip_p]].pr_flags & PR_LASTHDR) {
-		/*
-		 * Check if the packet has already had IPsec processing
-		 * done.  If so, then just pass it along.  This tag gets
-		 * set during AH, ESP, etc. input handling, before the
-		 * packet is returned to the ip input queue for delivery.
-		 */
-		mtag = m_tag_find(m, PACKET_TAG_IPSEC_IN_DONE, NULL);
-		crit_enter();
-		if (mtag != NULL) {
-			tdbi = (struct tdb_ident *)m_tag_data(mtag);
-			sp = ipsec_getpolicy(tdbi, IPSEC_DIR_INBOUND);
-		} else {
-			sp = ipsec_getpolicybyaddr(m, IPSEC_DIR_INBOUND,
-						   IP_FORWARDING, &error);
-		}
-		if (sp != NULL) {
-			/*
-			 * Check security policy against packet attributes.
-			 */
-			error = ipsec_in_reject(sp, m);
-			KEY_FREESP(&sp);
-		} else {
-			/* XXX error stat??? */
-			error = EINVAL;
-DPRINTF(("ip_input: no SP, packet discarded\n"));/*XXX*/
-			crit_exit();
-			goto bad;
-		}
-		crit_exit();
-		if (error)
-			goto bad;
-	}
-#endif /* FAST_IPSEC */
 
 	/*
 	 * We must forward the packet to the correct protocol thread if
@@ -2133,101 +2021,8 @@ ip_forward(struct mbuf *m, boolean_t using_srcrt, struct sockaddr_in *next_hop)
 	case EMSGSIZE:
 		type = ICMP_UNREACH;
 		code = ICMP_UNREACH_NEEDFRAG;
-#ifdef IPSEC
-		/*
-		 * If the packet is routed over IPsec tunnel, tell the
-		 * originator the tunnel MTU.
-		 *	tunnel MTU = if MTU - sizeof(IP) - ESP/AH hdrsiz
-		 * XXX quickhack!!!
-		 */
-		if (fwd_ro.ro_rt != NULL) {
-			struct secpolicy *sp = NULL;
-			int ipsecerror;
-			int ipsechdr;
-			struct route *ro;
-
-			sp = ipsec4_getpolicybyaddr(mcopy,
-						    IPSEC_DIR_OUTBOUND,
-						    IP_FORWARDING,
-						    &ipsecerror);
-
-			if (sp == NULL)
-				destmtu = fwd_ro.ro_rt->rt_ifp->if_mtu;
-			else {
-				/* count IPsec header size */
-				ipsechdr = ipsec4_hdrsiz(mcopy,
-							 IPSEC_DIR_OUTBOUND,
-							 NULL);
-
-				/*
-				 * find the correct route for outer IPv4
-				 * header, compute tunnel MTU.
-				 *
-				 */
-				if (sp->req != NULL && sp->req->sav != NULL &&
-				    sp->req->sav->sah != NULL) {
-					ro = &sp->req->sav->sah->sa_route;
-					if (ro->ro_rt != NULL &&
-					    ro->ro_rt->rt_ifp != NULL) {
-						destmtu =
-						    ro->ro_rt->rt_ifp->if_mtu;
-						destmtu -= ipsechdr;
-					}
-				}
-
-				key_freesp(sp);
-			}
-		}
-#elif defined(FAST_IPSEC)
-		/*
-		 * If the packet is routed over IPsec tunnel, tell the
-		 * originator the tunnel MTU.
-		 *	tunnel MTU = if MTU - sizeof(IP) - ESP/AH hdrsiz
-		 * XXX quickhack!!!
-		 */
-		if (fwd_ro.ro_rt != NULL) {
-			struct secpolicy *sp = NULL;
-			int ipsecerror;
-			int ipsechdr;
-			struct route *ro;
-
-			sp = ipsec_getpolicybyaddr(mcopy,
-						   IPSEC_DIR_OUTBOUND,
-						   IP_FORWARDING,
-						   &ipsecerror);
-
-			if (sp == NULL)
-				destmtu = fwd_ro.ro_rt->rt_ifp->if_mtu;
-			else {
-				/* count IPsec header size */
-				ipsechdr = ipsec4_hdrsiz(mcopy,
-							 IPSEC_DIR_OUTBOUND,
-							 NULL);
-
-				/*
-				 * find the correct route for outer IPv4
-				 * header, compute tunnel MTU.
-				 */
-
-				if (sp->req != NULL &&
-				    sp->req->sav != NULL &&
-				    sp->req->sav->sah != NULL) {
-					ro = &sp->req->sav->sah->sa_route;
-					if (ro->ro_rt != NULL &&
-					    ro->ro_rt->rt_ifp != NULL) {
-						destmtu =
-						    ro->ro_rt->rt_ifp->if_mtu;
-						destmtu -= ipsechdr;
-					}
-				}
-
-				KEY_FREESP(&sp);
-			}
-		}
-#else /* !IPSEC && !FAST_IPSEC */
 		if (fwd_ro.ro_rt != NULL)
 			destmtu = fwd_ro.ro_rt->rt_ifp->if_mtu;
-#endif /*IPSEC*/
 		ipstat.ips_cantfrag++;
 		break;
 
